<template>
  <span v-if="stopPropagation" @submit.capture.stop="_submit($event)">
    <slot />
  </span>
  <span v-else @submit="_submit($event)">
    <slot />
  </span>
</template>

<script>
import { WebSocketEventBus } from "./WebSocketEventBus";

export default {
  name: "on-submit",
  props: {
    configurationId: String,
    type: String,
    payload: Object,
    intent: String,
    stopPropagation: Boolean,
    onMessage: Function,
    onOpen: Function,
    onError: Function,
    onClose: Function,
    disabled: Boolean,
    blacklist: Array.of(String),
    keyType: String,
    customPrefix: String,
  },
  methods: {
    _handle: function(payload, text) {
      if (!this.configurationId) {
        console.error("[OnSubmit] Missing configurationId prop!");
        return;
      }
      if (this.disabled) {
        return;
      }
      let message = {
        type: this.type || "data",
      };
      if (this.type === "utterance") {
        message["utterance"] = text;
      } else {
        message["payload"] = this.payload || payload;
        if (this.intent) {
          message.payload = { ...message.payload, intent: this.intent };
        }
      }
      let packet = {
        configurationId: this.configurationId,
        message,
      };
      console.debug(
        `[OnSubmit]: ${JSON.stringify(message)} for ${this.configurationId}`
      );
      WebSocketEventBus.$emit("send", packet);
    },
    _submit: function(e) {
      e.preventDefault();
      let payload = {};
      let text;

      // Framework compliant utterance type
      if (this.type === "utterance") {
        text = e.target[0].value;
      }

      // Standard OnSubmit type
      else {
        // for each element in the form
        for (let i = 0; i < e.target.length; i++) {
          let t = e.target[i];

          if (!this.blacklist || !this.blacklist.includes(t.type)) {
            let value =
              t.type === "checkbox" || t.type === "radio" ? t.checked : t.value;

            switch (this.keyType) {
              case "attribute": {
                payload[t[this.attributeName]] = value;
                break;
              }
              case "label": {
                t.parentNode.childNodes.forEach((child) => {
                  if (child.nodeName === "LABEL") {
                    let label = child.textContent;
                    payload[label] = value;
                  }
                });
                break;
              }
              case "custom": {
                payload[`${this.customPrefix}${i}`] = value;
                break;
              }
              default: {
                break;
              }
            }
          }
        }
      }
      this._handle(payload, text);
      e.target.reset();
    },
  },

  mounted() {
    WebSocketEventBus.$emit("connect", {
      configurationId: this.configurationId,
      interaction: localStorage.getItem("mmcc-interaction") || null,
    });
    WebSocketEventBus.onOpen(this.onOpen);
    WebSocketEventBus.onError(this.onError);
    WebSocketEventBus.onMessage(this.onMessage);
    WebSocketEventBus.onClose(this.onClose);
  },
};
</script>
